/**
 * Bull SAS / OW2 Orchestra
 * Copyright (C) 2010 Bull S.A.S, and individual contributors as indicated
 * by the @authors tag.
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
 * USA
 */
package org.ow2.orchestra.designer.commands {
  import com.adobe.cairngorm.commands.ICommand;
  import com.adobe.cairngorm.control.CairngormEvent;

  import org.ow2.orchestra.designer.bpmn.model.AbstractElementWithPosition;
  import org.ow2.orchestra.designer.bpmn.model.ProcessModel;
  import org.ow2.orchestra.designer.bpmn.model.SequenceFlowModel;
  import org.ow2.orchestra.designer.bpmn.model.utils.IDUtil;
  import org.ow2.orchestra.designer.events.SequenceFlowEvent;

  public class CreateSequenceFlowCMD implements ICommand {
    public function CreateSequenceFlowCMD() {
    }

    /**
     * Executes the command.
     *  @param event a FlowEvent
     */
    public function execute(event:CairngormEvent):void {
      var flowEvt:SequenceFlowEvent = event as SequenceFlowEvent;
      trace("CreateFlowCMD");

      // save process model
      flowEvt.processEditorModel.saveModelForUndo();
      // Create flow
      createSequenceFlow(flowEvt.sourceElement, flowEvt.targetElement, flowEvt.processEditorModel.processModel);
    }

    public static function createSequenceFlow(sourceElement:AbstractElementWithPosition, targetElement:AbstractElementWithPosition, processModel:ProcessModel):SequenceFlowModel {
      // Create flow
      var newFlowModel:SequenceFlowModel = new SequenceFlowModel();
      newFlowModel.sourceElement = sourceElement;
      newFlowModel.targetElement = targetElement;
      newFlowModel.id = IDUtil.generateId();

      newFlowModel.processModel = processModel;
      processModel.elements.addItem(newFlowModel);
      return newFlowModel;
    }
  }
}
