/**
 * Bull SAS / OW2 Orchestra
 * Copyright (C) 2010 Bull S.A.S, and individual contributors as indicated
 * by the @authors tag.
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
 * USA
 */
package org.ow2.orchestra.designer.events {
  import com.adobe.cairngorm.control.CairngormEvent;

  import mx.collections.ArrayCollection;

  import org.ow2.orchestra.designer.model.ProcessEditorModel;

  public class ProcessEvent extends CairngormEvent {
    /**
     * Close a process.
     */
    public static const PROCESS_CLOSE:String = "ProcessEvent_CloseProcess";

    /**
     * Select a process.
     */
    public static const PROCESS_SELECT:String = "ProcessEvent_SelectProcess";

    /**
     * Delete selected elements of the process.
     */
    public static const PROCESS_SELECTED_ELEMENTS_DELETE:String = "ProcessEvent_DeleteSelectedElementsProcess";

    private var _processEditorModel:ProcessEditorModel;

    private var _currentlySelectedElements:ArrayCollection = new ArrayCollection();

    public function ProcessEvent(type:String, processEditorModel:ProcessEditorModel, bubbles:Boolean = false, cancelable:Boolean = false) {
      super(type, bubbles, cancelable);
      _processEditorModel = processEditorModel;
      if (processEditorModel != null) {
        _currentlySelectedElements.addAll(processEditorModel.selectedElements);
      }
    }

    public function get processEditorModel():ProcessEditorModel {
      return _processEditorModel;
    }

    public function get currentlySelectedElements():ArrayCollection {
      return _currentlySelectedElements;
    }

  }
}
