/**
 * Bull SAS / OW2 Orchestra
 * Copyright (C) 2010 Bull S.A.S, and individual contributors as indicated
 * by the @authors tag.
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
 * USA
 */
package org.ow2.orchestra.designer.events {
  import org.ow2.orchestra.designer.model.ProcessEditorModel;

  public class ProcessSelectionElementCoordinatesChangeEvent extends ProcessEvent {

    /**
     * Update list of selected process element.
     */
    public static const COORDINATES_CHANGE:String = "ProcessSelectionElementCoordinatesChangeEvent_ChangeCoordinates";

    //delta to move into x abscisse
    private var _deltaX:int;
    //delta to move into y abscisse
    private var _deltaY:int;

    public function ProcessSelectionElementCoordinatesChangeEvent(type:String, processEditorModel:ProcessEditorModel, deltaX:int, deltaY:int, bubbles:Boolean =
            false, cancelable:Boolean = false) {
      super(type, processEditorModel, bubbles, cancelable);
      _deltaX = deltaX;
      _deltaY = deltaY;
    }

    public function get deltaY():int {
      return _deltaY;
    }

    public function get deltaX():int {
      return _deltaX;
    }

  }
}
