/**
 * Bull SAS / OW2 Orchestra
 * Copyright (C) 2010 Bull S.A.S, and individual contributors as indicated
 * by the @authors tag.
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
 * USA
 */
package org.ow2.orchestra.designer.view.palette {
  import mx.containers.HBox;
  import mx.controls.Image;
  import mx.controls.Label;

  public class AbstractElementPalette extends HBox {

    protected var imageElement:Image;
    protected var imageSource:Class;

    protected var imageWidth:int;
    protected var imageHeight:int;

    // size of image elements include into the palette
    private static const DEFAULT_IMAGE_WIDTH:int = 30;
    private static const DEFAULT_IMAGE_HEIGHT:int = 30;

    public function AbstractElementPalette(sourceImage:Class, labelText:String, width:int = DEFAULT_IMAGE_WIDTH, height:int = DEFAULT_IMAGE_HEIGHT) {
      imageWidth = width;
      imageHeight = height;
      imageSource = sourceImage;
      imageElement = duplicateImage();

      this.setStyle("horizontalAlign", "center");

      var label:Label = new Label();
      label.text = labelText;

      this.addChild(imageElement);
      this.addChild(label);
    }


    public function duplicateImage():Image {
      var imageGateway:Image = new Image();
      imageGateway.source = imageSource;
      imageGateway.width = imageWidth;
      imageGateway.height = imageHeight;

      return imageGateway;
    }

  }
}
